=== debian/changelog ===
vcmi (1.4.1+dfsg-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:28:40 +1100

vcmi (1.4.1+dfsg-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:25:58 +0000

vcmi (1.4.1+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libminizip1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 03:32:06 +0000

vcmi (1.4.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.4.1+dfsg
  * refresh patches
  * also generate man page date from SOURCE_DATE_EPOCH

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Tue, 19 Dec 2023 21:12:28 +0100

vcmi (1.3.2+dfsg-2) unstable; urgency=medium

  * debian/patches: add fix-armel-atomics.patch

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Thu, 26 Oct 2023 15:14:58 +0200

vcmi (1.3.2+dfsg-1) unstable; urgency=medium

  [ Johannes Schauer Marin Rodrigues ]
  * New upstream version 1.3.2+dfsg
  * refresh patches
  * debian/copyright: Mods/vcmi/Maps/VCMI_Tests_2011b.h3m is no longer in
    upstream tarball
  * debian/copyright: exclude android directory
  * documentation moved to ./docs
  * debian/control: add B-D on qttools5-dev
  * debian/rules: add exception for false-positive blhc
  * allow cross-building with help2man by storing the man generated man pages

  [ Vagrant Cascadian ]
  * debian/rules: Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON via dh_auto_configure.
    (Closes: #1036572)
  * add patch Replace build year with present in copyright declarations.
    (Closes: #1036571)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Tue, 24 Oct 2023 06:25:43 +0200
